com::lomiri::location Namespace Reference

## Namespaces

namespace | connectivity
namespace | providers
namespace | service
namespace | units
namespace | wgs84

## Classes

struct | AccuracyTraits
struct | Accuracy
struct | Clock
| Defines the timebase of the location service. More...
struct | Criteria
| Summarizes criteria of a client session with respect to functionality and accuracy for position, velocity and heading measurements. More...
class | DefaultProviderSelectionPolicy
class | FusionProvider
struct | FusionProviderSelectionPolicy
class | NewerOrMoreAccurateUpdateSelector
class | NewerUpdateSelector
struct | Position
| The Position struct models a position in the wgs84 coordinate system. More...
class | Provider
| The Provider class is the abstract base of all positioning providers. More...
class | ProviderEnumerator
class | ProviderFactory
struct | ProviderSelection
class | ProviderSelectionPolicy
class | ProxyProvider
struct | SpaceVehicle
| A space-vehicle as visible to providers. More...
struct | Update
| Templated class that wraps a value and timestamp. More...
struct | WithSource
class | UpdateSelector

## Typedefs

typedef boost::property_tree::ptree | Configuration
typedef units::Quantity< units::PlaneAngle > | Heading
template<typename T>
using | Optional = boost::optional<T>
typedef units::Quantity< units::Velocity > | Velocity
| Velocity is measured in m/s.

## Enumerations

enum class | AccuracyLevel { country , region , locality , postalcode , street , detailed , best = detailed , worst = country }
enum class | SatelliteBasedPositioningState { on , off }
| The SatelliteBasedPositioningState enum describes whether satellite assisted positioning is enabled or disabled. More...
enum class | WifiAndCellIdReportingState { on , off }

## Functions

template<typename T>
std::ostream & | operator<< (std::ostream &out, const Accuracy< T > &update)
Criteria | operator+ (const Criteria &lhs, const Criteria &rhs)
| operator + merges lhs and rhs such that satisfying the new criteria satisfies lhs and rhs.
void | init (int *argc, char ***argv)
| Initializes the library.
void | shutdown ()
| Shuts down the library and frees all acquired resources.
std::ostream & | operator<< (std::ostream &out, const Position &position)
units::Quantity< units::Length > | haversine_distance (const Position &p1, const Position &p2)
Provider::Features | operator| (Provider::Features lhs, Provider::Features rhs)
Provider::Features | operator& (Provider::Features lhs, Provider::Features rhs)
Provider::Requirements | operator| (Provider::Requirements lhs, Provider::Requirements rhs)
Provider::Requirements | operator& (Provider::Requirements lhs, Provider::Requirements rhs)
bool | operator== (const ProviderSelection &lhs, const ProviderSelection &rhs)
std::ostream & | operator<< (std::ostream &, SatelliteBasedPositioningState)
| Pretty prints the given state to the given stream.
std::istream & | operator>> (std::istream &, SatelliteBasedPositioningState &)
| Parses the state from the given stream.
std::ostream & | operator<< (std::ostream &out, const SpaceVehicle &sv)
template<typename T>
std::ostream & | operator<< (std::ostream &out, const Update< T > &update)
| Pretty-prints the update to the provided output stream.
std::ostream & | operator<< (std::ostream &, WifiAndCellIdReportingState)
| Pretty prints the given state to the given stream.
std::istream & | operator>> (std::istream &, WifiAndCellIdReportingState &)
| Parses the state from the given stream.

## Typedef Documentation

## Configuration

typedef boost::property_tree::ptree com::lomiri::location::Configuration

Definition at line 29 of file configuration.h.

## Heading

typedef units::Quantity<units::PlaneAngle> com::lomiri::location::Heading

Heading is measured in ° deviation from true north.

Definition at line 30 of file heading.h.

## Optional

template<typename T>

using com::lomiri::location::Optional = boost::optional<T>

Definition at line 31 of file optional.h.

## Velocity

typedef units::Quantity<units::Velocity> com::lomiri::location::Velocity

Velocity is measured in m/s.

Definition at line 30 of file velocity.h.

## Enumeration Type Documentation

## AccuracyLevel

enum class com::lomiri::location::AccuracyLevel

strong

Enumerator
country |
region |
locality |
postalcode |
street |
detailed |
best |
worst |

Definition at line 29 of file accuracy.h.

## SatelliteBasedPositioningState

enum class com::lomiri::location::SatelliteBasedPositioningState

strong

The SatelliteBasedPositioningState enum describes whether satellite assisted positioning is enabled or disabled.

Enumerator
on | Satellite assisted positioning is on.
off | Satellite assisted positioning is off.

Definition at line 33 of file satellite_based_positioning_state.h.

## WifiAndCellIdReportingState

enum class com::lomiri::location::WifiAndCellIdReportingState

strong

Enumerator
on | Wifi and Cell Ids might be reported to online location services.
off | Wifi and Cell Ids are not reported. This is the default value.

Definition at line 29 of file wifi_and_cell_reporting_state.h.

## Function Documentation

## haversine_distance()

units::Quantity< units::Length > com::lomiri::location::haversine_distance | ( | const Position & | p1,
|  | const Position & | p2 )

## init()

void com::lomiri::location::init | ( | int * | argc,
|  | char *** | argv )

Initializes the library.

## operator&() [1/2]

Provider::Features com::lomiri::location::operator& | ( | Provider::Features | lhs,
|  | Provider::Features | rhs )

## operator&() [2/2]

Provider::Requirements com::lomiri::location::operator& | ( | Provider::Requirements | lhs,
|  | Provider::Requirements | rhs )

## operator+()

Criteria com::lomiri::location::operator+ | ( | const Criteria & | lhs,
|  | const Criteria & | rhs )

operator + merges lhs and rhs such that satisfying the new criteria satisfies lhs and rhs.

## operator<<() [1/6]

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | ,
|  | SatelliteBasedPositioningState | )

Pretty prints the given state to the given stream.

## operator<<() [2/6]

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | ,
|  | WifiAndCellIdReportingState | )

Pretty prints the given state to the given stream.

## operator<<() [3/6]

template<typename T>

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | out,
|  | const Accuracy< T > & | update )

inline

Definition at line 68 of file accuracy.h.

References com::lomiri::location::Accuracy< T >::value.

## operator<<() [4/6]

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | out,
|  | const Position & | position )

## operator<<() [5/6]

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | out,
|  | const SpaceVehicle & | sv )

inline

Definition at line 95 of file space_vehicle.h.

References com::lomiri::location::SpaceVehicle::azimuth, com::lomiri::location::SpaceVehicle::beidou, com::lomiri::location::SpaceVehicle::compass, com::lomiri::location::SpaceVehicle::elevation, com::lomiri::location::SpaceVehicle::galileo, com::lomiri::location::SpaceVehicle::glonass, com::lomiri::location::SpaceVehicle::gps, com::lomiri::location::SpaceVehicle::has_almanac_data, com::lomiri::location::SpaceVehicle::has_ephimeris_data, com::lomiri::location::SpaceVehicle::Key::id, com::lomiri::location::SpaceVehicle::irnss, com::lomiri::location::SpaceVehicle::key, com::lomiri::location::SpaceVehicle::qzss, com::lomiri::location::SpaceVehicle::snr, com::lomiri::location::SpaceVehicle::Key::type, com::lomiri::location::SpaceVehicle::unknown, and com::lomiri::location::SpaceVehicle::used_in_fix.

## operator<<() [6/6]

template<typename T>

std::ostream & com::lomiri::location::operator<< | ( | std::ostream & | out,
|  | const Update< T > & | update )

inline

Pretty-prints the update to the provided output stream.

Parameters

  out | The stream to write to.
  update | The value to be printed.

Definition at line 82 of file update.h.

References com::lomiri::location::Update< T >::value, and com::lomiri::location::Update< T >::when.

## operator==()

bool com::lomiri::location::operator== | ( | const ProviderSelection & | lhs,
|  | const ProviderSelection & | rhs )

inline

Definition at line 52 of file provider_selection.h.

References com::lomiri::location::ProviderSelection::heading_updates_provider, com::lomiri::location::ProviderSelection::position_updates_provider, and com::lomiri::location::ProviderSelection::velocity_updates_provider.

## operator>>() [1/2]

std::istream & com::lomiri::location::operator>> | ( | std::istream & | ,
|  | SatelliteBasedPositioningState & | )

Parses the state from the given stream.

## operator>>() [2/2]

std::istream & com::lomiri::location::operator>> | ( | std::istream & | ,
|  | WifiAndCellIdReportingState & | )

Parses the state from the given stream.

## operator|() [1/2]

Provider::Features com::lomiri::location::operator| | ( | Provider::Features | lhs,
|  | Provider::Features | rhs )

## operator|() [2/2]

Provider::Requirements com::lomiri::location::operator| | ( | Provider::Requirements | lhs,
|  | Provider::Requirements | rhs )

## shutdown()

void com::lomiri::location::shutdown | ( |  | ) |

Shuts down the library and frees all acquired resources.